﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using WinForm.Wizard;

namespace WinForm.Wizard
{
    [ProvideProperty("WizardSteps", typeof(WizardStepCollection)), Designer(typeof(WizardDesigner))]
    public partial class Wizard : UserControl
    {
        public readonly WizardStepCollection WizardSteps = new WizardStepCollection();
        private WizardStep activateWizardStep = null;
        private int activateStep = 0;

        public Wizard()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            try
            {
                ActivateWizardStep = WizardSteps.Items(ActivateStep);
            }
            catch { }
        }

        public void WizardStep_Add(string Title)
        {
            WizardSteps.Add(Title);
            ActivateStep = WizardSteps.Count - 1;
            ActivateWizardStep = WizardSteps.Items(ActivateStep);
            Controls.Add(activateWizardStep);
            Container.Add(activateWizardStep);
        }

        public void WizardStep_Add(WizardStep step)
        {
            step.Size = Size;
            WizardSteps.Add(step);
            ActivateStep = WizardSteps.Count - 1;
            Container.Add(step);
        }

        public void WizardStep_Remove(string StepName)
        {
            Controls.Remove(activateWizardStep);
            Container.Remove(activateWizardStep);
            WizardSteps.Remove(StepName);
            ActivateStep = 0;
        }

        public void Cancel()
        {
            WizardSteps.Clear();
            ActivateStep = 0;
        }

        public int ActivateStep
        {
            get { return activateStep; }
            set
            {
                if (value >= 0)
                {
                    activateStep = value;
                    ActivateWizardStep = WizardSteps.Items(activateStep);
                }
            }
        }

        protected override void OnControlAdded(ControlEventArgs e)
        {
            base.OnControlAdded(e);
            WizardSteps.Add((WizardStep)e.Control);
        }

        public WizardStep ActivateWizardStep
        {
            get { return activateWizardStep; }
            set
            {
                try
                {
                    activateWizardStep.Visible = false;
                }
                catch { }

                activateWizardStep = value;

                try
                {
                    activateWizardStep.Visible = true;
                }
                catch { }
            }
        }

        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);
            try
            {
                //WizardSteps.Items(activateStep).Size = Size;
            }
            catch
            {
            }
        }
    }
}