
using System.Drawing;

namespace WinForm.Wizard
{
    public class WizardStepCollection : System.Collections.CollectionBase
    {
        public void Add(string StepName)//, System.Drawing.Size size)
        {
            WizardStep step = new WizardStep(StepName);
            step.Size = new Size(300,100);
            List.Add(step);
        }

        public void Add(WizardStep step)
        {
            if (step.Name == "")
                step.Name = "Wizard Step" + (Count + 1);
            step.Size = new Size(300, 100);
            List.Add(step);
        }

        public void Remove(string Name)
        {
            for(int i=0;i<Count;i++)
            {
                if (Items(i).Name == Name)
                {
                    List.RemoveAt(i);
                    break;
                }
            }
        }

        public WizardStep Items(int Index)
        {
            if(List.Count - Index > 0)
                return (WizardStep) List[Index];
            else
                return null;
        }

        public string[] ToStrings()
        {
            string[] str = new string[Count];
            int i = 0;

            foreach(WizardStep ws in this)
            {
                str[i] = ws.Name;
                i++;
            }

            return str;
        }
    }
}